/*******************************************************************************
 * Copyright (c) 2003 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/cpl-v10.html
 * 
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/
package org.eclipse.hyades.models.common.facades.behavioral;

/**
 * 
 * An external implementor is something that implements the test that is not 
 * modeled in the current test system.  An external implementor is characterized 
 * by a location and a resource that specifies where and what is to be invoked.
 * 
 * @author marcelop
 * @author psun
 * @since 
 */
public interface IExternalImplementor extends IImplementor
{
	/**
	 * Returns the resouce of the external implementor.
	 * 
	 * @return String
	 */	
	public String getResource();

	/**
	 * Sets the resouce of the external implementor.
	 * 
	 * @param resource
	 */	
	public void setResource(String resource);
	
	/**
	 * Returns the location of the external implementor.
	 * 
	 * @return String
	 */		
	public String getLocation();

	/**
	 * Sets the location of the external implementor.
	 * 
	 * @param location
	 */	
	public void setLocation(String location);	
}
