/*******************************************************************************
 * Copyright (c) 2003 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/cpl-v10.html
 * 
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/
package org.eclipse.hyades.models.common.facades.behavioral;

/**
 * 
 * A test component is the implementation of a test that can be invoked.
 * 
 * A test component is commonly an active class used to specify test cases as 
 * interactions between a number of test components with the SUT. The behavior 
 * of a test component can be used to specify low level test behavior, or it 
 * can be automatically derived from all the test case behaviors in which the 
 * component takes part.
 * 
 * @author jtoomey
 * @author serge
 * @author marcelop
 * @author psun
 * @since 0.0.1
 */
public interface ITestComponent extends IDeployableComponent, IImplementor {

	/**
	 * Returns the block that contains the list of actions for a test case.
	 * 
	 * <p>This reference is unidirectional
	 * 
	 * @return IBlock
	 */
	public IBlock getBlock();
}