/*
 * Created on May 15, 2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package org.eclipse.hyades.models.common.facades.behavioral.test;

import java.io.File;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;

import org.eclipse.hyades.models.common.facades.behavioral.IAction;
import org.eclipse.hyades.models.common.facades.behavioral.IBlock;
import org.eclipse.hyades.models.common.facades.behavioral.ICondition;
import org.eclipse.hyades.models.common.facades.behavioral.IDecision;
import org.eclipse.hyades.models.common.facades.behavioral.ILoop;
import org.eclipse.hyades.models.common.facades.behavioral.ISystemUnderTest;
import org.eclipse.hyades.models.common.facades.behavioral.ITargetInvocation;
import org.eclipse.hyades.models.common.facades.behavioral.ITest;
import org.eclipse.hyades.models.common.facades.behavioral.ITestCase;
import org.eclipse.hyades.models.common.facades.behavioral.ITestComponent;
import org.eclipse.hyades.models.common.facades.behavioral.ITestInvocation;
import org.eclipse.hyades.models.common.facades.behavioral.ITestSuite;
import org.eclipse.hyades.models.common.facades.behavioral.IVerificationPoint;
import org.eclipse.hyades.models.common.facades.behavioral.impl.HyadesFactory;

/**
 * @author psun
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class ValidateFacadeImpl extends TestCase {

	Resource resource = null;

	public ValidateFacadeImpl(String name)
	{
		super(name);
	}

	public static Test suite()
	{
		TestSuite junitTestSuite = new TestSuite("EMF Facade Impl Validation");
		
		junitTestSuite.addTest(new ValidateFacadeImpl("suiteSetUp"));
		junitTestSuite.addTest(new ValidateFacadeImpl("testTestSuiteCreation"));
		junitTestSuite.addTest(new ValidateFacadeImpl("testTestSuiteModification"));
		junitTestSuite.addTest(new ValidateFacadeImpl("testAddAction"));
		junitTestSuite.addTest(new ValidateFacadeImpl("suiteTearDown"));
		
		return junitTestSuite;
	}
	
	public void suiteSetUp()
	{ 
	}
		
	public void suiteTearDown()
	{ 
	}
	
	public void testTestSuiteCreation()
	{
		ITestSuite testSuite = createTestSuite();
		ITestCase testCase = createTestCase();
		ITestComponent testComponent = createTestComponent(testSuite);
		testComponent.setName("Test Component 1");
		testComponent.setDescription("A generic test component");
		testComponent.setLocation("C:\temp");
		testComponent.setResource("testComponent1.java");
		ISystemUnderTest systemUnderTest = createSystemUnderTest();
		systemUnderTest.setName("System Under Test 1");
		systemUnderTest.setDescription("A generic system under test");
		systemUnderTest.setLocation("C:\temp");
		systemUnderTest.setResource("systemUnderTest1.java");
		
		testSuite.setName("Test Suite 1");
		testSuite.setDescription("A simple Test Suite with one of everythiing");
		testSuite.getITestCases().add(0, testCase);
		testSuite.getISystemsUnderTest().add(0, systemUnderTest);
		testSuite.getITestComponents().add(0, testComponent);
		testSuite.setImplementor(testComponent);
		
		// check object		
		assertEquals(testSuite.getName(), "Test Suite 1");
		assertEquals(testSuite.getDescription(), "A Simple Test Suite with one of everything");
		assertEquals(testSuite.getITestCases().get(0), testCase);
		assertEquals(testSuite.getITestComponents().get(0), testComponent);
		assertEquals(testSuite.getISystemsUnderTest().get(0), systemUnderTest);		
		assertEquals(testSuite.getImplementor(), testComponent);

		// save and reload into another object				
		save(testSuite, "TestSuite1");
		ITestSuite reloadedTestSuite = (ITestSuite)load("TestSuite1");
		
		// check reloaded object
		assertEquals(reloadedTestSuite.getName(), "Test Suite 1");
		assertEquals(reloadedTestSuite.getDescription(), "A Test Suite with one of everything");
		assertEquals(reloadedTestSuite.getITestCases().get(0), testCase);
		assertEquals(reloadedTestSuite.getITestComponents().get(0), testComponent);
		assertEquals(reloadedTestSuite.getISystemsUnderTest().get(0), systemUnderTest);		
		assertEquals(reloadedTestSuite.getImplementor(), testComponent);
	}
	
	public void testTestSuiteModification()
	{
		ITestSuite testSuite = (ITestSuite)load("TestSuite1");
		
		// change some values
		
		ITestComponent newTestComponent = createTestComponent(testSuite);
		newTestComponent.setName("Test Component 2");
		newTestComponent.setDescription("A generic test component");
		newTestComponent.setLocation("C:\temp");
		newTestComponent.setResource("testComponent2.java");

		testSuite.setName("Changed Test Suite");
		testSuite.setDescription("A changed Test Suite");
		testSuite.setImplementor(newTestComponent);
		
		// add/remove some elements
		
		ISystemUnderTest systemUnderTest2 = createSystemUnderTest();
		ISystemUnderTest systemUnderTest3 = createSystemUnderTest();
		systemUnderTest2.setName("System Under Test 2");
		systemUnderTest2.setDescription("A generic system under test");
		systemUnderTest2.setLocation("C:\temp");
		systemUnderTest2.setResource("systemUnderTest2.java");

		systemUnderTest3.setName("System Under Test 3");
		systemUnderTest3.setDescription("A generic system under test");
		systemUnderTest3.setLocation("C:\temp");
		systemUnderTest3.setResource("systemUnderTest3.java");

		
		testSuite.getISystemsUnderTest().remove(0);
		testSuite.getISystemsUnderTest().add(0, systemUnderTest2);
		testSuite.getISystemsUnderTest().add(1, systemUnderTest3);
		
		// check object
		assertEquals(testSuite.getName(), "Changed Test Suite");
		assertEquals(testSuite.getDescription(), "A changed Test Suite");
		assertEquals(testSuite.getImplementor(), newTestComponent);
		assertEquals(testSuite.getISystemsUnderTest().size(), 2);
		assertEquals(testSuite.getISystemsUnderTest().get(0), systemUnderTest2);
		assertEquals(testSuite.getISystemsUnderTest().get(1), systemUnderTest3);
		assertEquals(((ISystemUnderTest)testSuite.getISystemsUnderTest().get(0)).getName(), "System Under Test 2");
		
		// save and reload into another object		
		save(testSuite, "TestSuite1");
		ITestSuite reloadedTestSuite = (ITestSuite)load("TestSuite1");
		
		// check reloaded object
		assertEquals(reloadedTestSuite.getName(), "Changed Test Suite");
		assertEquals(reloadedTestSuite.getDescription(), "A changed Test Suite");
		assertEquals(reloadedTestSuite.getImplementor(), newTestComponent);
		assertEquals(reloadedTestSuite.getISystemsUnderTest().get(0), systemUnderTest2);
		assertEquals(reloadedTestSuite.getISystemsUnderTest().get(1), systemUnderTest3);
		assertEquals(((ISystemUnderTest)reloadedTestSuite.getISystemsUnderTest().get(0)).getName(), "System Under Test 2");		
	}
	
	public void testAddAction()
	{
		ITestSuite testSuite = (ITestSuite)load("TestSuite1");
		ITestComponent testComponent = (ITestComponent)testSuite.getITestComponents().get(0);
		IBlock block = testComponent.getBlock();	
		
		// create some actions
		IVerificationPoint actionVP = createVerificationPoint();
		actionVP.setName("VP 1");
		actionVP.setDescription("A generic VP");
		ITargetInvocation actionTargetInvocation = createTargetInvocation();
		ITestInvocation actionTestInvocation = createTestInvocation();
		
		// create a decision
		
		// TODO: Does passing block make sense
		IDecision decision = createDecision(block);
		ICondition condition = createCondition();
		condition.setConstraint("i>5");
		condition.setName("Condition 1");
		condition.setDescription("Less than 5");
		
		decision.setCondition(condition);
		decision.getSuccessBlock().getActions().add(0, actionTestInvocation);
		decision.getSuccessBlock().getActions().add(1, actionVP);
		decision.getFailureBlock().getActions().add(0, actionTargetInvocation);
		
		testComponent.getBlock().getActions().add(0, decision);

		// check object
		ITestComponent tempTestComponent = 	(ITestComponent)testSuite.getITestComponents().get(0);
		IAction tempAction = (IAction)tempTestComponent.getBlock().getActions().get(0);
		assertEquals(tempAction, decision);
		assertEquals(((IDecision)tempAction).getCondition(), "i<5");
		assertEquals(((IDecision)tempAction).getSuccessBlock().getActions().size(), 2);
		assertEquals(((IDecision)tempAction).getFailureBlock().getActions().size(), 1);
		assertEquals(((IDecision)tempAction).getSuccessBlock().getActions().get(0), actionVP);
		assertEquals(((IDecision)tempAction).getSuccessBlock().getActions().get(1), actionVP);
		assertEquals(((IDecision)tempAction).getFailureBlock().getActions().get(0), actionTargetInvocation);
		
		// save and reload into another object		
		save(testSuite, "TestSuite1");
		ITestSuite reloadedTestSuite = (ITestSuite)load("TestSuite1");

		// check object
		
		tempTestComponent = (ITestComponent)reloadedTestSuite.getITestComponents().get(0);
		tempAction = (IAction)tempTestComponent.getBlock().getActions().get(0);
		assertEquals(tempAction, decision);
		assertEquals(((IDecision)tempAction).getCondition(), "i<5");
		assertEquals(((IDecision)tempAction).getSuccessBlock().getActions().size(), 2);
		assertEquals(((IDecision)tempAction).getFailureBlock().getActions().size(), 1);
		assertEquals(((IDecision)tempAction).getSuccessBlock().getActions().get(0), actionVP);
		assertEquals(((IDecision)tempAction).getSuccessBlock().getActions().get(1), actionVP);
		assertEquals(((IDecision)tempAction).getFailureBlock().getActions().get(0), actionTargetInvocation);
		
	}
	
	private ITestSuite createTestSuite()
	{
		return HyadesFactory.INSTANCE.createTestSuite(resource);	
	}
	
	private ITestCase createTestCase()
	{
		return HyadesFactory.INSTANCE.createTestCase(resource);
	}
	
	private ITestComponent createTestComponent(ITest implementedTest)
	{
		return HyadesFactory.INSTANCE.createTestComponent(resource, implementedTest);	
	}
		
	private ISystemUnderTest createSystemUnderTest()
	{
		return HyadesFactory.INSTANCE.createSystemUnderTest(resource);	
	}
	
	private IDecision createDecision(IBlock block)
	{
		return HyadesFactory.INSTANCE.createDecision(block);
	}

	private ILoop createLoop(IBlock block)
	{
		return HyadesFactory.INSTANCE.createLoop(block);	
	}
		
	private IVerificationPoint createVerificationPoint()
	{
		return HyadesFactory.INSTANCE.createVerificationPoint();
	}
		
	private ITargetInvocation createTargetInvocation()
	{
		return HyadesFactory.INSTANCE.createTargetInvocation();
	}

	private ITestInvocation createTestInvocation()
	{
		return HyadesFactory.INSTANCE.createTestInvocation();
	}
		
	private ICondition createCondition()
	{
		return HyadesFactory.INSTANCE.createCondition();
	}
			
	private void save(Object obj, String objURI)
	{
		if(resource == null)
		{
			ResourceSet resourceSet = new ResourceSetImpl();
			URI fileURI = URI.createFileURI(new File(objURI).getAbsolutePath());
			resource = resourceSet.createResource(fileURI);
		}
		resource.getContents().add(obj);
	}
	
	private Object load(String objURI)
	{
		ResourceSet resourceSet = new ResourceSetImpl();
		resource = resourceSet.getResource(URI.createURI(objURI), true);
		return resource.getClass().getClass();				
	}
}
