/**
 * <copyright>
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package org.eclipse.hyades.models.common.configuration;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see org.eclipse.hyades.models.common.configuration.Common_ConfigurationFactory
 * @generated
 */
public interface Common_ConfigurationPackage extends EPackage
{
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "configuration";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.eclipse.org/hyades/models/common/configuration.xmi";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "Common_Configuration";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	Common_ConfigurationPackage eINSTANCE = org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl.init();

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.CFGLocationImpl <em>CFG Location</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.CFGLocationImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getCFGLocation()
	 * @generated
	 */
	int CFG_LOCATION = 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_LOCATION__NAME = 0;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_LOCATION__DESCRIPTION = 1;

	/**
	 * The feature id for the '<em><b>Deployment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_LOCATION__DEPLOYMENT = 2;

	/**
	 * The feature id for the '<em><b>Timezone</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_LOCATION__TIMEZONE = 3;

	/**
	 * The feature id for the '<em><b>Sub Locations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_LOCATION__SUB_LOCATIONS = 4;

	/**
	 * The feature id for the '<em><b>Parent</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_LOCATION__PARENT = 5;

	/**
	 * The feature id for the '<em><b>Artifacts</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_LOCATION__ARTIFACTS = 6;

	/**
	 * The number of structural features of the the '<em>CFG Location</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_LOCATION_FEATURE_COUNT = 7;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.CFGDeployableImpl <em>CFG Deployable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.CFGDeployableImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getCFGDeployable()
	 * @generated
	 */
	int CFG_DEPLOYABLE = 1;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_DEPLOYABLE__ID = 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_DEPLOYABLE__NAME = 1;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_DEPLOYABLE__DESCRIPTION = 2;

	/**
	 * The feature id for the '<em><b>Behavior Resource</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_DEPLOYABLE__BEHAVIOR_RESOURCE = 3;

	/**
	 * The feature id for the '<em><b>Behavior Location</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_DEPLOYABLE__BEHAVIOR_LOCATION = 4;

	/**
	 * The feature id for the '<em><b>Operations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_DEPLOYABLE__OPERATIONS = 5;

	/**
	 * The feature id for the '<em><b>Lifelines</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_DEPLOYABLE__LIFELINES = 6;

	/**
	 * The feature id for the '<em><b>Artifacts</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_DEPLOYABLE__ARTIFACTS = 7;

	/**
	 * The feature id for the '<em><b>Instances</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_DEPLOYABLE__INSTANCES = 8;

	/**
	 * The number of structural features of the the '<em>CFG Deployable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_DEPLOYABLE_FEATURE_COUNT = 9;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.CFGOperationImpl <em>CFG Operation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.CFGOperationImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getCFGOperation()
	 * @generated
	 */
	int CFG_OPERATION = 2;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_OPERATION__NAME = 0;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_OPERATION__DESCRIPTION = 1;

	/**
	 * The feature id for the '<em><b>Deployable</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_OPERATION__DEPLOYABLE = 2;

	/**
	 * The number of structural features of the the '<em>CFG Operation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_OPERATION_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.CFGArtifactImpl <em>CFG Artifact</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.CFGArtifactImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getCFGArtifact()
	 * @generated
	 */
	int CFG_ARTIFACT = 3;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_ARTIFACT__NAME = 0;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_ARTIFACT__DESCRIPTION = 1;

	/**
	 * The feature id for the '<em><b>Deployable Instances</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_ARTIFACT__DEPLOYABLE_INSTANCES = 2;

	/**
	 * The feature id for the '<em><b>Deployment Spec</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_ARTIFACT__DEPLOYMENT_SPEC = 3;

	/**
	 * The feature id for the '<em><b>Location</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_ARTIFACT__LOCATION = 4;

	/**
	 * The feature id for the '<em><b>Deployment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_ARTIFACT__DEPLOYMENT = 5;

	/**
	 * The feature id for the '<em><b>Instances</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_ARTIFACT__INSTANCES = 6;

	/**
	 * The number of structural features of the the '<em>CFG Artifact</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_ARTIFACT_FEATURE_COUNT = 7;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.CFGDeploymentSpecImpl <em>CFG Deployment Spec</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.CFGDeploymentSpecImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getCFGDeploymentSpec()
	 * @generated
	 */
	int CFG_DEPLOYMENT_SPEC = 4;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_DEPLOYMENT_SPEC__NAME = 0;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_DEPLOYMENT_SPEC__DESCRIPTION = 1;

	/**
	 * The feature id for the '<em><b>Deployment Location</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_DEPLOYMENT_SPEC__DEPLOYMENT_LOCATION = 2;

	/**
	 * The feature id for the '<em><b>Execution Location</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_DEPLOYMENT_SPEC__EXECUTION_LOCATION = 3;

	/**
	 * The feature id for the '<em><b>Concurrency Mode</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_DEPLOYMENT_SPEC__CONCURRENCY_MODE = 4;

	/**
	 * The feature id for the '<em><b>Artifact</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_DEPLOYMENT_SPEC__ARTIFACT = 5;

	/**
	 * The feature id for the '<em><b>Deployment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_DEPLOYMENT_SPEC__DEPLOYMENT = 6;

	/**
	 * The number of structural features of the the '<em>CFG Deployment Spec</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_DEPLOYMENT_SPEC_FEATURE_COUNT = 7;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.impl.CFGInstanceImpl <em>CFG Instance</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.impl.CFGInstanceImpl
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getCFGInstance()
	 * @generated
	 */
	int CFG_INSTANCE = 5;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_INSTANCE__NAME = 0;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_INSTANCE__DESCRIPTION = 1;

	/**
	 * The feature id for the '<em><b>Count</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_INSTANCE__COUNT = 2;

	/**
	 * The feature id for the '<em><b>Deployable Owner</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_INSTANCE__DEPLOYABLE_OWNER = 3;

	/**
	 * The feature id for the '<em><b>Artifact</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_INSTANCE__ARTIFACT = 4;

	/**
	 * The feature id for the '<em><b>Deployable Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_INSTANCE__DEPLOYABLE_TYPE = 5;

	/**
	 * The number of structural features of the the '<em>CFG Instance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CFG_INSTANCE_FEATURE_COUNT = 6;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.common.configuration.CFGConcurrency <em>CFG Concurrency</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.common.configuration.CFGConcurrency
	 * @see org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl#getCFGConcurrency()
	 * @generated
	 */
	int CFG_CONCURRENCY = 6;


	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.CFGLocation <em>CFG Location</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>CFG Location</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGLocation
	 * @generated
	 */
	EClass getCFGLocation();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.CFGLocation#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGLocation#getName()
	 * @see #getCFGLocation()
	 * @generated
	 */
	EAttribute getCFGLocation_Name();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.CFGLocation#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Description</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGLocation#getDescription()
	 * @see #getCFGLocation()
	 * @generated
	 */
	EAttribute getCFGLocation_Description();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.hyades.models.common.configuration.CFGLocation#getDeployment <em>Deployment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Deployment</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGLocation#getDeployment()
	 * @see #getCFGLocation()
	 * @generated
	 */
	EReference getCFGLocation_Deployment();

	/**
	 * Returns the meta object for the reference '{@link org.eclipse.hyades.models.common.configuration.CFGLocation#getTimezone <em>Timezone</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Timezone</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGLocation#getTimezone()
	 * @see #getCFGLocation()
	 * @generated
	 */
	EReference getCFGLocation_Timezone();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.hyades.models.common.configuration.CFGLocation#getSubLocations <em>Sub Locations</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Sub Locations</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGLocation#getSubLocations()
	 * @see #getCFGLocation()
	 * @generated
	 */
	EReference getCFGLocation_SubLocations();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.hyades.models.common.configuration.CFGLocation#getParent <em>Parent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Parent</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGLocation#getParent()
	 * @see #getCFGLocation()
	 * @generated
	 */
	EReference getCFGLocation_Parent();

	/**
	 * Returns the meta object for the reference list '{@link org.eclipse.hyades.models.common.configuration.CFGLocation#getArtifacts <em>Artifacts</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Artifacts</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGLocation#getArtifacts()
	 * @see #getCFGLocation()
	 * @generated
	 */
	EReference getCFGLocation_Artifacts();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.CFGDeployable <em>CFG Deployable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>CFG Deployable</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGDeployable
	 * @generated
	 */
	EClass getCFGDeployable();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.CFGDeployable#getId <em>Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Id</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGDeployable#getId()
	 * @see #getCFGDeployable()
	 * @generated
	 */
	EAttribute getCFGDeployable_Id();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.CFGDeployable#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGDeployable#getName()
	 * @see #getCFGDeployable()
	 * @generated
	 */
	EAttribute getCFGDeployable_Name();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.CFGDeployable#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Description</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGDeployable#getDescription()
	 * @see #getCFGDeployable()
	 * @generated
	 */
	EAttribute getCFGDeployable_Description();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.CFGDeployable#getBehaviorResource <em>Behavior Resource</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Behavior Resource</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGDeployable#getBehaviorResource()
	 * @see #getCFGDeployable()
	 * @generated
	 */
	EAttribute getCFGDeployable_BehaviorResource();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.CFGDeployable#getBehaviorLocation <em>Behavior Location</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Behavior Location</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGDeployable#getBehaviorLocation()
	 * @see #getCFGDeployable()
	 * @generated
	 */
	EAttribute getCFGDeployable_BehaviorLocation();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.hyades.models.common.configuration.CFGDeployable#getOperations <em>Operations</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Operations</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGDeployable#getOperations()
	 * @see #getCFGDeployable()
	 * @generated
	 */
	EReference getCFGDeployable_Operations();

	/**
	 * Returns the meta object for the reference list '{@link org.eclipse.hyades.models.common.configuration.CFGDeployable#getLifelines <em>Lifelines</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Lifelines</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGDeployable#getLifelines()
	 * @see #getCFGDeployable()
	 * @generated
	 */
	EReference getCFGDeployable_Lifelines();

	/**
	 * Returns the meta object for the reference list '{@link org.eclipse.hyades.models.common.configuration.CFGDeployable#getArtifacts <em>Artifacts</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Artifacts</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGDeployable#getArtifacts()
	 * @see #getCFGDeployable()
	 * @generated
	 */
	EReference getCFGDeployable_Artifacts();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.hyades.models.common.configuration.CFGDeployable#getInstances <em>Instances</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Instances</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGDeployable#getInstances()
	 * @see #getCFGDeployable()
	 * @generated
	 */
	EReference getCFGDeployable_Instances();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.CFGOperation <em>CFG Operation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>CFG Operation</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGOperation
	 * @generated
	 */
	EClass getCFGOperation();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.CFGOperation#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGOperation#getName()
	 * @see #getCFGOperation()
	 * @generated
	 */
	EAttribute getCFGOperation_Name();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.CFGOperation#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Description</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGOperation#getDescription()
	 * @see #getCFGOperation()
	 * @generated
	 */
	EAttribute getCFGOperation_Description();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.hyades.models.common.configuration.CFGOperation#getDeployable <em>Deployable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Deployable</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGOperation#getDeployable()
	 * @see #getCFGOperation()
	 * @generated
	 */
	EReference getCFGOperation_Deployable();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.CFGArtifact <em>CFG Artifact</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>CFG Artifact</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGArtifact
	 * @generated
	 */
	EClass getCFGArtifact();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.CFGArtifact#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGArtifact#getName()
	 * @see #getCFGArtifact()
	 * @generated
	 */
	EAttribute getCFGArtifact_Name();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.CFGArtifact#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Description</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGArtifact#getDescription()
	 * @see #getCFGArtifact()
	 * @generated
	 */
	EAttribute getCFGArtifact_Description();

	/**
	 * Returns the meta object for the reference list '{@link org.eclipse.hyades.models.common.configuration.CFGArtifact#getDeployableInstances <em>Deployable Instances</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Deployable Instances</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGArtifact#getDeployableInstances()
	 * @see #getCFGArtifact()
	 * @generated
	 */
	EReference getCFGArtifact_DeployableInstances();

	/**
	 * Returns the meta object for the reference '{@link org.eclipse.hyades.models.common.configuration.CFGArtifact#getDeploymentSpec <em>Deployment Spec</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Deployment Spec</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGArtifact#getDeploymentSpec()
	 * @see #getCFGArtifact()
	 * @generated
	 */
	EReference getCFGArtifact_DeploymentSpec();

	/**
	 * Returns the meta object for the reference '{@link org.eclipse.hyades.models.common.configuration.CFGArtifact#getLocation <em>Location</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Location</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGArtifact#getLocation()
	 * @see #getCFGArtifact()
	 * @generated
	 */
	EReference getCFGArtifact_Location();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.hyades.models.common.configuration.CFGArtifact#getDeployment <em>Deployment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Deployment</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGArtifact#getDeployment()
	 * @see #getCFGArtifact()
	 * @generated
	 */
	EReference getCFGArtifact_Deployment();

	/**
	 * Returns the meta object for the reference list '{@link org.eclipse.hyades.models.common.configuration.CFGArtifact#getInstances <em>Instances</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Instances</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGArtifact#getInstances()
	 * @see #getCFGArtifact()
	 * @generated
	 */
	EReference getCFGArtifact_Instances();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.CFGDeploymentSpec <em>CFG Deployment Spec</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>CFG Deployment Spec</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGDeploymentSpec
	 * @generated
	 */
	EClass getCFGDeploymentSpec();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.CFGDeploymentSpec#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGDeploymentSpec#getName()
	 * @see #getCFGDeploymentSpec()
	 * @generated
	 */
	EAttribute getCFGDeploymentSpec_Name();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.CFGDeploymentSpec#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Description</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGDeploymentSpec#getDescription()
	 * @see #getCFGDeploymentSpec()
	 * @generated
	 */
	EAttribute getCFGDeploymentSpec_Description();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.CFGDeploymentSpec#getDeploymentLocation <em>Deployment Location</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Deployment Location</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGDeploymentSpec#getDeploymentLocation()
	 * @see #getCFGDeploymentSpec()
	 * @generated
	 */
	EAttribute getCFGDeploymentSpec_DeploymentLocation();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.CFGDeploymentSpec#getExecutionLocation <em>Execution Location</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Execution Location</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGDeploymentSpec#getExecutionLocation()
	 * @see #getCFGDeploymentSpec()
	 * @generated
	 */
	EAttribute getCFGDeploymentSpec_ExecutionLocation();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.CFGDeploymentSpec#getConcurrencyMode <em>Concurrency Mode</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Concurrency Mode</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGDeploymentSpec#getConcurrencyMode()
	 * @see #getCFGDeploymentSpec()
	 * @generated
	 */
	EAttribute getCFGDeploymentSpec_ConcurrencyMode();

	/**
	 * Returns the meta object for the reference list '{@link org.eclipse.hyades.models.common.configuration.CFGDeploymentSpec#getArtifact <em>Artifact</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Artifact</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGDeploymentSpec#getArtifact()
	 * @see #getCFGDeploymentSpec()
	 * @generated
	 */
	EReference getCFGDeploymentSpec_Artifact();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.hyades.models.common.configuration.CFGDeploymentSpec#getDeployment <em>Deployment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Deployment</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGDeploymentSpec#getDeployment()
	 * @see #getCFGDeploymentSpec()
	 * @generated
	 */
	EReference getCFGDeploymentSpec_Deployment();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.common.configuration.CFGInstance <em>CFG Instance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>CFG Instance</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGInstance
	 * @generated
	 */
	EClass getCFGInstance();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.CFGInstance#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGInstance#getName()
	 * @see #getCFGInstance()
	 * @generated
	 */
	EAttribute getCFGInstance_Name();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.CFGInstance#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Description</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGInstance#getDescription()
	 * @see #getCFGInstance()
	 * @generated
	 */
	EAttribute getCFGInstance_Description();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.common.configuration.CFGInstance#getCount <em>Count</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Count</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGInstance#getCount()
	 * @see #getCFGInstance()
	 * @generated
	 */
	EAttribute getCFGInstance_Count();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.hyades.models.common.configuration.CFGInstance#getDeployableOwner <em>Deployable Owner</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Deployable Owner</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGInstance#getDeployableOwner()
	 * @see #getCFGInstance()
	 * @generated
	 */
	EReference getCFGInstance_DeployableOwner();

	/**
	 * Returns the meta object for the reference '{@link org.eclipse.hyades.models.common.configuration.CFGInstance#getArtifact <em>Artifact</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Artifact</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGInstance#getArtifact()
	 * @see #getCFGInstance()
	 * @generated
	 */
	EReference getCFGInstance_Artifact();

	/**
	 * Returns the meta object for the reference '{@link org.eclipse.hyades.models.common.configuration.CFGInstance#getDeployableType <em>Deployable Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Deployable Type</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGInstance#getDeployableType()
	 * @see #getCFGInstance()
	 * @generated
	 */
	EReference getCFGInstance_DeployableType();

	/**
	 * Returns the meta object for enum '{@link org.eclipse.hyades.models.common.configuration.CFGConcurrency <em>CFG Concurrency</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>CFG Concurrency</em>'.
	 * @see org.eclipse.hyades.models.common.configuration.CFGConcurrency
	 * @generated
	 */
	EEnum getCFGConcurrency();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	Common_ConfigurationFactory getCommon_ConfigurationFactory();

} //Common_ConfigurationPackage
