/**
 * <copyright>
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package org.eclipse.hyades.models.common.configuration.util;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;

import org.eclipse.hyades.models.common.configuration.*;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage
 * @generated
 */
public class Common_ConfigurationSwitch
{
	/**
	 * The cached model package
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static Common_ConfigurationPackage modelPackage;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Common_ConfigurationSwitch()
	{
		if (modelPackage == null)
		{
			modelPackage = Common_ConfigurationPackage.eINSTANCE;
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	public Object doSwitch(EObject theEObject)
	{
		EClass theEClass = theEObject.eClass();
		if (theEClass.eContainer() == modelPackage)
		{
			switch (theEClass.getClassifierID())
			{
				case Common_ConfigurationPackage.CFG_LOCATION:
				{
					CFGLocation cfgLocation = (CFGLocation)theEObject;
					Object result = caseCFGLocation(cfgLocation);
					if (result == null) result = defaultCase(theEObject);
					return result;
				}
				case Common_ConfigurationPackage.CFG_OPERATION:
				{
					CFGOperation cfgOperation = (CFGOperation)theEObject;
					Object result = caseCFGOperation(cfgOperation);
					if (result == null) result = defaultCase(theEObject);
					return result;
				}
				case Common_ConfigurationPackage.CFG_ARTIFACT:
				{
					CFGArtifact cfgArtifact = (CFGArtifact)theEObject;
					Object result = caseCFGArtifact(cfgArtifact);
					if (result == null) result = defaultCase(theEObject);
					return result;
				}
				case Common_ConfigurationPackage.CFG_DEPLOYMENT_SPEC:
				{
					CFGDeploymentSpec cfgDeploymentSpec = (CFGDeploymentSpec)theEObject;
					Object result = caseCFGDeploymentSpec(cfgDeploymentSpec);
					if (result == null) result = defaultCase(theEObject);
					return result;
				}
				case Common_ConfigurationPackage.CFG_INSTANCE:
				{
					CFGInstance cfgInstance = (CFGInstance)theEObject;
					Object result = caseCFGInstance(cfgInstance);
					if (result == null) result = defaultCase(theEObject);
					return result;
				}
				default: return defaultCase(theEObject);
			}
		}
		return defaultCase(theEObject);
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>CFG Location</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>CFG Location</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseCFGLocation(CFGLocation object)
	{
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>CFG Deployable</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>CFG Deployable</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseCFGDeployable(CFGDeployable object)
	{
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>CFG Operation</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>CFG Operation</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseCFGOperation(CFGOperation object)
	{
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>CFG Artifact</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>CFG Artifact</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseCFGArtifact(CFGArtifact object)
	{
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>CFG Deployment Spec</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>CFG Deployment Spec</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseCFGDeploymentSpec(CFGDeploymentSpec object)
	{
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>CFG Instance</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>CFG Instance</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseCFGInstance(CFGInstance object)
	{
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>EObject</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch, but this is the last case anyway.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	public Object defaultCase(EObject object)
	{
		return null;
	}

} //Common_ConfigurationSwitch
