/*******************************************************************************
 * Copyright (c) 2003 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/cpl-v10.html
 * 
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/
package org.eclipse.hyades.models.common.facades.behavioral.impl;

import java.util.List;

import org.eclipse.hyades.models.common.facades.behavioral.IBlock;

/**
 * @author marcelop
 * @since 
 */
public class BlockImpl implements IBlock
{
	private String name;
	private String description;
	private List actions;
	
	/**
	 * @see org.eclipse.hyades.models.test.facades.simple.IBlock#getActions()
	 */
	public List getActions()
	{
		return actions;
	}
	
	public void setActions(List actions)
	{
		this.actions = actions;
	}

	/**
	 * @see org.eclipse.hyades.models.test.facades.simple.INamedElement#getName()
	 */
	public String getName()
	{
		return name;
	}

	/**
	 * @see org.eclipse.hyades.models.test.facades.simple.INamedElement#setName(java.lang.String)
	 */
	public void setName(String name)
	{
		this.name = name;
	}

	/**
	 * @see org.eclipse.hyades.models.test.facades.simple.INamedElement#getDescription()
	 */
	public String getDescription()
	{
		return description;
	}

	/**
	 * @see org.eclipse.hyades.models.test.facades.simple.INamedElement#setDescription(java.lang.String)
	 */
	public void setDescription(String description)
	{
		this.description = description;
	}
}
