/**
 * <copyright>
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package org.eclipse.hyades.models.common.interactions.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import org.eclipse.hyades.models.common.fragments.BVRInteraction;
import org.eclipse.hyades.models.common.fragments.Common_Behavior_FragmentsPackage;

import org.eclipse.hyades.models.common.interactions.BVREventOccurrence;
import org.eclipse.hyades.models.common.interactions.BVRExecutionOccurrence;
import org.eclipse.hyades.models.common.interactions.BVRGeneralOrdering;
import org.eclipse.hyades.models.common.interactions.Common_Behavior_InteractionsPackage;

import org.eclipse.hyades.models.common.testprofile.TPFDefaultApplication;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>BVR Event Occurrence</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.common.interactions.impl.BVREventOccurrenceImpl#getTargetGeneralOrderings <em>Target General Orderings</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.interactions.impl.BVREventOccurrenceImpl#getSourceGeneralOrderings <em>Source General Orderings</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.interactions.impl.BVREventOccurrenceImpl#getFinishExecutionOccurrence <em>Finish Execution Occurrence</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.interactions.impl.BVREventOccurrenceImpl#getStartExecutionOcurrence <em>Start Execution Ocurrence</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class BVREventOccurrenceImpl extends BVRInteractionFragmentImpl implements BVREventOccurrence
{
	/**
	 * The cached value of the '{@link #getTargetGeneralOrderings() <em>Target General Orderings</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTargetGeneralOrderings()
	 * @generated
	 * @ordered
	 */
	protected EList targetGeneralOrderings = null;

	/**
	 * The cached value of the '{@link #getSourceGeneralOrderings() <em>Source General Orderings</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSourceGeneralOrderings()
	 * @generated
	 * @ordered
	 */
	protected EList sourceGeneralOrderings = null;

	/**
	 * The cached value of the '{@link #getFinishExecutionOccurrence() <em>Finish Execution Occurrence</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFinishExecutionOccurrence()
	 * @generated
	 * @ordered
	 */
	protected BVRExecutionOccurrence finishExecutionOccurrence = null;

	/**
	 * The cached value of the '{@link #getStartExecutionOcurrence() <em>Start Execution Ocurrence</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStartExecutionOcurrence()
	 * @generated
	 * @ordered
	 */
	protected BVRExecutionOccurrence startExecutionOcurrence = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BVREventOccurrenceImpl()
	{
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass()
	{
		return Common_Behavior_InteractionsPackage.eINSTANCE.getBVREventOccurrence();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getTargetGeneralOrderings()
	{
		if (targetGeneralOrderings == null)
		{
			targetGeneralOrderings = new EObjectWithInverseResolvingEList(BVRGeneralOrdering.class, this, Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__TARGET_GENERAL_ORDERINGS, Common_Behavior_InteractionsPackage.BVR_GENERAL_ORDERING__PREVIOUS_EVENT_OCCURRENCE);
		}
		return targetGeneralOrderings;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getSourceGeneralOrderings()
	{
		if (sourceGeneralOrderings == null)
		{
			sourceGeneralOrderings = new EObjectWithInverseResolvingEList(BVRGeneralOrdering.class, this, Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__SOURCE_GENERAL_ORDERINGS, Common_Behavior_InteractionsPackage.BVR_GENERAL_ORDERING__NEXT_EVENT_OCCURENCE);
		}
		return sourceGeneralOrderings;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BVRExecutionOccurrence getFinishExecutionOccurrence()
	{
		if (finishExecutionOccurrence != null && finishExecutionOccurrence.eIsProxy())
		{
			BVRExecutionOccurrence oldFinishExecutionOccurrence = finishExecutionOccurrence;
			finishExecutionOccurrence = (BVRExecutionOccurrence)EcoreUtil.resolve(finishExecutionOccurrence, this);
			if (finishExecutionOccurrence != oldFinishExecutionOccurrence)
			{
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__FINISH_EXECUTION_OCCURRENCE, oldFinishExecutionOccurrence, finishExecutionOccurrence));
			}
		}
		return finishExecutionOccurrence;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BVRExecutionOccurrence basicGetFinishExecutionOccurrence()
	{
		return finishExecutionOccurrence;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetFinishExecutionOccurrence(BVRExecutionOccurrence newFinishExecutionOccurrence, NotificationChain msgs)
	{
		BVRExecutionOccurrence oldFinishExecutionOccurrence = finishExecutionOccurrence;
		finishExecutionOccurrence = newFinishExecutionOccurrence;
		if (eNotificationRequired())
		{
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__FINISH_EXECUTION_OCCURRENCE, oldFinishExecutionOccurrence, newFinishExecutionOccurrence);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setFinishExecutionOccurrence(BVRExecutionOccurrence newFinishExecutionOccurrence)
	{
		if (newFinishExecutionOccurrence != finishExecutionOccurrence)
		{
			NotificationChain msgs = null;
			if (finishExecutionOccurrence != null)
				msgs = ((InternalEObject)finishExecutionOccurrence).eInverseRemove(this, Common_Behavior_InteractionsPackage.BVR_EXECUTION_OCCURRENCE__FINISH_EVENT_OCCURRENCE, BVRExecutionOccurrence.class, msgs);
			if (newFinishExecutionOccurrence != null)
				msgs = ((InternalEObject)newFinishExecutionOccurrence).eInverseAdd(this, Common_Behavior_InteractionsPackage.BVR_EXECUTION_OCCURRENCE__FINISH_EVENT_OCCURRENCE, BVRExecutionOccurrence.class, msgs);
			msgs = basicSetFinishExecutionOccurrence(newFinishExecutionOccurrence, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__FINISH_EXECUTION_OCCURRENCE, newFinishExecutionOccurrence, newFinishExecutionOccurrence));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BVRExecutionOccurrence getStartExecutionOcurrence()
	{
		if (startExecutionOcurrence != null && startExecutionOcurrence.eIsProxy())
		{
			BVRExecutionOccurrence oldStartExecutionOcurrence = startExecutionOcurrence;
			startExecutionOcurrence = (BVRExecutionOccurrence)EcoreUtil.resolve(startExecutionOcurrence, this);
			if (startExecutionOcurrence != oldStartExecutionOcurrence)
			{
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__START_EXECUTION_OCURRENCE, oldStartExecutionOcurrence, startExecutionOcurrence));
			}
		}
		return startExecutionOcurrence;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BVRExecutionOccurrence basicGetStartExecutionOcurrence()
	{
		return startExecutionOcurrence;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetStartExecutionOcurrence(BVRExecutionOccurrence newStartExecutionOcurrence, NotificationChain msgs)
	{
		BVRExecutionOccurrence oldStartExecutionOcurrence = startExecutionOcurrence;
		startExecutionOcurrence = newStartExecutionOcurrence;
		if (eNotificationRequired())
		{
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__START_EXECUTION_OCURRENCE, oldStartExecutionOcurrence, newStartExecutionOcurrence);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setStartExecutionOcurrence(BVRExecutionOccurrence newStartExecutionOcurrence)
	{
		if (newStartExecutionOcurrence != startExecutionOcurrence)
		{
			NotificationChain msgs = null;
			if (startExecutionOcurrence != null)
				msgs = ((InternalEObject)startExecutionOcurrence).eInverseRemove(this, Common_Behavior_InteractionsPackage.BVR_EXECUTION_OCCURRENCE__BEFORE_EVENT_OCCURRENCE, BVRExecutionOccurrence.class, msgs);
			if (newStartExecutionOcurrence != null)
				msgs = ((InternalEObject)newStartExecutionOcurrence).eInverseAdd(this, Common_Behavior_InteractionsPackage.BVR_EXECUTION_OCCURRENCE__BEFORE_EVENT_OCCURRENCE, BVRExecutionOccurrence.class, msgs);
			msgs = basicSetStartExecutionOcurrence(newStartExecutionOcurrence, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__START_EXECUTION_OCURRENCE, newStartExecutionOcurrence, newStartExecutionOcurrence));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs)
	{
		if (featureID >= 0)
		{
			switch (eDerivedStructuralFeatureID(featureID, baseClass))
			{
				case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__LIFELINES:
					return ((InternalEList)getLifelines()).basicAdd(otherEnd, msgs);
				case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__MESSAGES:
					return ((InternalEList)getMessages()).basicAdd(otherEnd, msgs);
				case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__INTERACTION:
					if (eContainer != null)
						msgs = eBasicRemoveFromContainer(msgs);
					return eBasicSetContainer(otherEnd, Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__INTERACTION, msgs);
				case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__DEFAULT_APPLICATION:
					if (defaultApplication != null)
						msgs = ((InternalEObject)defaultApplication).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__DEFAULT_APPLICATION, null, msgs);
					return basicSetDefaultApplication((TPFDefaultApplication)otherEnd, msgs);
				case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__TARGET_GENERAL_ORDERINGS:
					return ((InternalEList)getTargetGeneralOrderings()).basicAdd(otherEnd, msgs);
				case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__SOURCE_GENERAL_ORDERINGS:
					return ((InternalEList)getSourceGeneralOrderings()).basicAdd(otherEnd, msgs);
				case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__FINISH_EXECUTION_OCCURRENCE:
					if (finishExecutionOccurrence != null)
						msgs = ((InternalEObject)finishExecutionOccurrence).eInverseRemove(this, Common_Behavior_InteractionsPackage.BVR_EXECUTION_OCCURRENCE__FINISH_EVENT_OCCURRENCE, BVRExecutionOccurrence.class, msgs);
					return basicSetFinishExecutionOccurrence((BVRExecutionOccurrence)otherEnd, msgs);
				case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__START_EXECUTION_OCURRENCE:
					if (startExecutionOcurrence != null)
						msgs = ((InternalEObject)startExecutionOcurrence).eInverseRemove(this, Common_Behavior_InteractionsPackage.BVR_EXECUTION_OCCURRENCE__BEFORE_EVENT_OCCURRENCE, BVRExecutionOccurrence.class, msgs);
					return basicSetStartExecutionOcurrence((BVRExecutionOccurrence)otherEnd, msgs);
				default:
					return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs)
	{
		if (featureID >= 0)
		{
			switch (eDerivedStructuralFeatureID(featureID, baseClass))
			{
				case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__LIFELINES:
					return ((InternalEList)getLifelines()).basicRemove(otherEnd, msgs);
				case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__GENERAL_ORDERINGS:
					return ((InternalEList)getGeneralOrderings()).basicRemove(otherEnd, msgs);
				case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__MESSAGES:
					return ((InternalEList)getMessages()).basicRemove(otherEnd, msgs);
				case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__PROPERTIES:
					return ((InternalEList)getProperties()).basicRemove(otherEnd, msgs);
				case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__INTERACTION:
					return eBasicSetContainer(null, Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__INTERACTION, msgs);
				case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__DEFAULT_APPLICATION:
					return basicSetDefaultApplication(null, msgs);
				case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__TARGET_GENERAL_ORDERINGS:
					return ((InternalEList)getTargetGeneralOrderings()).basicRemove(otherEnd, msgs);
				case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__SOURCE_GENERAL_ORDERINGS:
					return ((InternalEList)getSourceGeneralOrderings()).basicRemove(otherEnd, msgs);
				case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__FINISH_EXECUTION_OCCURRENCE:
					return basicSetFinishExecutionOccurrence(null, msgs);
				case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__START_EXECUTION_OCURRENCE:
					return basicSetStartExecutionOcurrence(null, msgs);
				default:
					return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs)
	{
		if (eContainerFeatureID >= 0)
		{
			switch (eContainerFeatureID)
			{
				case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__INTERACTION:
					return ((InternalEObject)eContainer).eInverseRemove(this, Common_Behavior_FragmentsPackage.BVR_INTERACTION__INTERACTION_FRAGMENTS, BVRInteraction.class, msgs);
				default:
					return eDynamicBasicRemoveFromContainer(msgs);
			}
		}
		return ((InternalEObject)eContainer).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve)
	{
		switch (eDerivedStructuralFeatureID(eFeature))
		{
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__ID:
				return getId();
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__NAME:
				return getName();
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__DESCRIPTION:
				return getDescription();
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__LIFELINES:
				return getLifelines();
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__GENERAL_ORDERINGS:
				return getGeneralOrderings();
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__MESSAGES:
				return getMessages();
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__PROPERTIES:
				return getProperties();
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__INTERACTION:
				return getInteraction();
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__DEFAULT_APPLICATION:
				return getDefaultApplication();
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__TARGET_GENERAL_ORDERINGS:
				return getTargetGeneralOrderings();
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__SOURCE_GENERAL_ORDERINGS:
				return getSourceGeneralOrderings();
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__FINISH_EXECUTION_OCCURRENCE:
				if (resolve) return getFinishExecutionOccurrence();
				return basicGetFinishExecutionOccurrence();
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__START_EXECUTION_OCURRENCE:
				if (resolve) return getStartExecutionOcurrence();
				return basicGetStartExecutionOcurrence();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue)
	{
		switch (eDerivedStructuralFeatureID(eFeature))
		{
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__ID:
				setId((String)newValue);
				return;
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__NAME:
				setName((String)newValue);
				return;
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__DESCRIPTION:
				setDescription((String)newValue);
				return;
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__LIFELINES:
				getLifelines().clear();
				getLifelines().addAll((Collection)newValue);
				return;
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__GENERAL_ORDERINGS:
				getGeneralOrderings().clear();
				getGeneralOrderings().addAll((Collection)newValue);
				return;
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__MESSAGES:
				getMessages().clear();
				getMessages().addAll((Collection)newValue);
				return;
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__PROPERTIES:
				getProperties().clear();
				getProperties().addAll((Collection)newValue);
				return;
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__INTERACTION:
				setInteraction((BVRInteraction)newValue);
				return;
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__DEFAULT_APPLICATION:
				setDefaultApplication((TPFDefaultApplication)newValue);
				return;
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__TARGET_GENERAL_ORDERINGS:
				getTargetGeneralOrderings().clear();
				getTargetGeneralOrderings().addAll((Collection)newValue);
				return;
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__SOURCE_GENERAL_ORDERINGS:
				getSourceGeneralOrderings().clear();
				getSourceGeneralOrderings().addAll((Collection)newValue);
				return;
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__FINISH_EXECUTION_OCCURRENCE:
				setFinishExecutionOccurrence((BVRExecutionOccurrence)newValue);
				return;
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__START_EXECUTION_OCURRENCE:
				setStartExecutionOcurrence((BVRExecutionOccurrence)newValue);
				return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature)
	{
		switch (eDerivedStructuralFeatureID(eFeature))
		{
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__ID:
				setId(ID_EDEFAULT);
				return;
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__NAME:
				setName(NAME_EDEFAULT);
				return;
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__DESCRIPTION:
				setDescription(DESCRIPTION_EDEFAULT);
				return;
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__LIFELINES:
				getLifelines().clear();
				return;
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__GENERAL_ORDERINGS:
				getGeneralOrderings().clear();
				return;
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__MESSAGES:
				getMessages().clear();
				return;
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__PROPERTIES:
				getProperties().clear();
				return;
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__INTERACTION:
				setInteraction((BVRInteraction)null);
				return;
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__DEFAULT_APPLICATION:
				setDefaultApplication((TPFDefaultApplication)null);
				return;
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__TARGET_GENERAL_ORDERINGS:
				getTargetGeneralOrderings().clear();
				return;
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__SOURCE_GENERAL_ORDERINGS:
				getSourceGeneralOrderings().clear();
				return;
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__FINISH_EXECUTION_OCCURRENCE:
				setFinishExecutionOccurrence((BVRExecutionOccurrence)null);
				return;
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__START_EXECUTION_OCURRENCE:
				setStartExecutionOcurrence((BVRExecutionOccurrence)null);
				return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature)
	{
		switch (eDerivedStructuralFeatureID(eFeature))
		{
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__ID:
				return ID_EDEFAULT == null ? id != null : !ID_EDEFAULT.equals(id);
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__DESCRIPTION:
				return DESCRIPTION_EDEFAULT == null ? description != null : !DESCRIPTION_EDEFAULT.equals(description);
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__LIFELINES:
				return lifelines != null && !lifelines.isEmpty();
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__GENERAL_ORDERINGS:
				return generalOrderings != null && !generalOrderings.isEmpty();
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__MESSAGES:
				return messages != null && !messages.isEmpty();
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__PROPERTIES:
				return properties != null && !properties.isEmpty();
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__INTERACTION:
				return getInteraction() != null;
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__DEFAULT_APPLICATION:
				return defaultApplication != null;
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__TARGET_GENERAL_ORDERINGS:
				return targetGeneralOrderings != null && !targetGeneralOrderings.isEmpty();
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__SOURCE_GENERAL_ORDERINGS:
				return sourceGeneralOrderings != null && !sourceGeneralOrderings.isEmpty();
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__FINISH_EXECUTION_OCCURRENCE:
				return finishExecutionOccurrence != null;
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__START_EXECUTION_OCURRENCE:
				return startExecutionOcurrence != null;
		}
		return eDynamicIsSet(eFeature);
	}

} //BVREventOccurrenceImpl
