/**
 * <copyright>
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package org.eclipse.hyades.models.common.testprofile.util;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

import org.eclipse.hyades.models.common.configuration.CFGDeployable;

import org.eclipse.hyades.models.common.interactions.BVREventOccurrence;
import org.eclipse.hyades.models.common.interactions.BVRInteractionFragment;

import org.eclipse.hyades.models.common.testprofile.*;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage
 * @generated
 */
public class Common_TestprofileAdapterFactory extends AdapterFactoryImpl
{
	/**
	 * The cached model package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static Common_TestprofilePackage modelPackage;

	/**
	 * Creates an instance of the adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Common_TestprofileAdapterFactory()
	{
		if (modelPackage == null)
		{
			modelPackage = Common_TestprofilePackage.eINSTANCE;
		}
	}

	/**
	 * Returns whether this factory is applicable for the type of the object.
	 * <!-- begin-user-doc -->
	 * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
	 * <!-- end-user-doc -->
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 */
	public boolean isFactoryForType(Object object)
	{
		if (object == modelPackage)
		{
			return true;
		}
		if (object instanceof EObject)
		{
			return ((EObject)object).eClass().getEPackage() == modelPackage;
		}
		return false;
	}

	/**
	 * The switch the delegates to the <code>createXXX</code> methods.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected Common_TestprofileSwitch modelSwitch =
		new Common_TestprofileSwitch()
		{
			public Object caseTPFDeployment(TPFDeployment object)
			{
				return createTPFDeploymentAdapter();
			}
			public Object caseTPFLiteralAnyorNull(TPFLiteralAnyorNull object)
			{
				return createTPFLiteralAnyorNullAdapter();
			}
			public Object caseTPFLiteralAny(TPFLiteralAny object)
			{
				return createTPFLiteralAnyAdapter();
			}
			public Object caseTPFInstanceValue(TPFInstanceValue object)
			{
				return createTPFInstanceValueAdapter();
			}
			public Object caseTPFExecutionResult(TPFExecutionResult object)
			{
				return createTPFExecutionResultAdapter();
			}
			public Object caseTPFLogAction(TPFLogAction object)
			{
				return createTPFLogActionAdapter();
			}
			public Object caseTPFDefault(TPFDefault object)
			{
				return createTPFDefaultAdapter();
			}
			public Object caseTPFDefaultApplication(TPFDefaultApplication object)
			{
				return createTPFDefaultApplicationAdapter();
			}
			public Object caseTPFBehavior(TPFBehavior object)
			{
				return createTPFBehaviorAdapter();
			}
			public Object caseTPFTestCase(TPFTestCase object)
			{
				return createTPFTestCaseAdapter();
			}
			public Object caseTPFArbiter(TPFArbiter object)
			{
				return createTPFArbiterAdapter();
			}
			public Object caseTPFCodingRule(TPFCodingRule object)
			{
				return createTPFCodingRuleAdapter();
			}
			public Object caseTPFSUT(TPFSUT object)
			{
				return createTPFSUTAdapter();
			}
			public Object caseTPFTestSuite(TPFTestSuite object)
			{
				return createTPFTestSuiteAdapter();
			}
			public Object caseTPFTestObjective(TPFTestObjective object)
			{
				return createTPFTestObjectiveAdapter();
			}
			public Object caseTPFTestComponent(TPFTestComponent object)
			{
				return createTPFTestComponentAdapter();
			}
			public Object caseTPFTimezone(TPFTimezone object)
			{
				return createTPFTimezoneAdapter();
			}
			public Object caseTPFValidationAction(TPFValidationAction object)
			{
				return createTPFValidationActionAdapter();
			}
			public Object caseTPFExecutionHistory(TPFExecutionHistory object)
			{
				return createTPFExecutionHistoryAdapter();
			}
			public Object caseTPFExecutionEvent(TPFExecutionEvent object)
			{
				return createTPFExecutionEventAdapter();
			}
			public Object caseTPFExecutionStatus(TPFExecutionStatus object)
			{
				return createTPFExecutionStatusAdapter();
			}
			public Object caseTPFInvocationEvent(TPFInvocationEvent object)
			{
				return createTPFInvocationEventAdapter();
			}
			public Object caseTPFVerdictEvent(TPFVerdictEvent object)
			{
				return createTPFVerdictEventAdapter();
			}
			public Object caseTPFMessageEvent(TPFMessageEvent object)
			{
				return createTPFMessageEventAdapter();
			}
			public Object caseTPFTypedEvent(TPFTypedEvent object)
			{
				return createTPFTypedEventAdapter();
			}
			public Object caseTPFTest(TPFTest object)
			{
				return createTPFTestAdapter();
			}
			public Object caseBVRInteractionFragment(BVRInteractionFragment object)
			{
				return createBVRInteractionFragmentAdapter();
			}
			public Object caseBVREventOccurrence(BVREventOccurrence object)
			{
				return createBVREventOccurrenceAdapter();
			}
			public Object caseCFGDeployable(CFGDeployable object)
			{
				return createCFGDeployableAdapter();
			}
			public Object defaultCase(EObject object)
			{
				return createEObjectAdapter();
			}
		};

	/**
	 * Creates an adapter for the <code>target</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param target the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 */
	public Adapter createAdapter(Notifier target)
	{
		return (Adapter)modelSwitch.doSwitch((EObject)target);
	}


	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFDeployment <em>TPF Deployment</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFDeployment
	 * @generated
	 */
	public Adapter createTPFDeploymentAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFLiteralAnyorNull <em>TPF Literal Anyor Null</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFLiteralAnyorNull
	 * @generated
	 */
	public Adapter createTPFLiteralAnyorNullAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFLiteralAny <em>TPF Literal Any</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFLiteralAny
	 * @generated
	 */
	public Adapter createTPFLiteralAnyAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFInstanceValue <em>TPF Instance Value</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFInstanceValue
	 * @generated
	 */
	public Adapter createTPFInstanceValueAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFExecutionResult <em>TPF Execution Result</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFExecutionResult
	 * @generated
	 */
	public Adapter createTPFExecutionResultAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFLogAction <em>TPF Log Action</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFLogAction
	 * @generated
	 */
	public Adapter createTPFLogActionAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFDefault <em>TPF Default</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFDefault
	 * @generated
	 */
	public Adapter createTPFDefaultAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFDefaultApplication <em>TPF Default Application</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFDefaultApplication
	 * @generated
	 */
	public Adapter createTPFDefaultApplicationAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFBehavior <em>TPF Behavior</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFBehavior
	 * @generated
	 */
	public Adapter createTPFBehaviorAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFTestCase <em>TPF Test Case</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFTestCase
	 * @generated
	 */
	public Adapter createTPFTestCaseAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFArbiter <em>TPF Arbiter</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFArbiter
	 * @generated
	 */
	public Adapter createTPFArbiterAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFCodingRule <em>TPF Coding Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFCodingRule
	 * @generated
	 */
	public Adapter createTPFCodingRuleAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFSUT <em>TPFSUT</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFSUT
	 * @generated
	 */
	public Adapter createTPFSUTAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFTestSuite <em>TPF Test Suite</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFTestSuite
	 * @generated
	 */
	public Adapter createTPFTestSuiteAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFTestObjective <em>TPF Test Objective</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFTestObjective
	 * @generated
	 */
	public Adapter createTPFTestObjectiveAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFTestComponent <em>TPF Test Component</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFTestComponent
	 * @generated
	 */
	public Adapter createTPFTestComponentAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFTimezone <em>TPF Timezone</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFTimezone
	 * @generated
	 */
	public Adapter createTPFTimezoneAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFValidationAction <em>TPF Validation Action</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFValidationAction
	 * @generated
	 */
	public Adapter createTPFValidationActionAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFExecutionHistory <em>TPF Execution History</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFExecutionHistory
	 * @generated
	 */
	public Adapter createTPFExecutionHistoryAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFExecutionEvent <em>TPF Execution Event</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFExecutionEvent
	 * @generated
	 */
	public Adapter createTPFExecutionEventAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFExecutionStatus <em>TPF Execution Status</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFExecutionStatus
	 * @generated
	 */
	public Adapter createTPFExecutionStatusAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFInvocationEvent <em>TPF Invocation Event</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFInvocationEvent
	 * @generated
	 */
	public Adapter createTPFInvocationEventAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFVerdictEvent <em>TPF Verdict Event</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFVerdictEvent
	 * @generated
	 */
	public Adapter createTPFVerdictEventAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFMessageEvent <em>TPF Message Event</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFMessageEvent
	 * @generated
	 */
	public Adapter createTPFMessageEventAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFTypedEvent <em>TPF Typed Event</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFTypedEvent
	 * @generated
	 */
	public Adapter createTPFTypedEventAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFTest <em>TPF Test</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFTest
	 * @generated
	 */
	public Adapter createTPFTestAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.interactions.BVRInteractionFragment <em>BVR Interaction Fragment</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.interactions.BVRInteractionFragment
	 * @generated
	 */
	public Adapter createBVRInteractionFragmentAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.interactions.BVREventOccurrence <em>BVR Event Occurrence</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.interactions.BVREventOccurrence
	 * @generated
	 */
	public Adapter createBVREventOccurrenceAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.configuration.CFGDeployable <em>CFG Deployable</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.configuration.CFGDeployable
	 * @generated
	 */
	public Adapter createCFGDeployableAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for the default case.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @generated
	 */
	public Adapter createEObjectAdapter()
	{
		return null;
	}

} //Common_TestprofileAdapterFactory
